{-------------------------------------------------------}
{                                                       }
{    The DBTreeNavigator example  Copyright 1996-1997   }
{         by Li Ying All Rights Reserved                }
{                  version 3.1                          }
{-------------------------------------------------------}

//**************************************************************
//  In this typical example ,we use DBTreeNavigator
//        in 1 optional step(OnRejustEvent) in the code writing .
//    And we show the use of the basic and important properties
//**************************************************************

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, ExtCtrls, DBCtrls, DB, DBTables, StdCtrls, Menus,
  ComCtrls , Mask, Treenavi, StruTree, RichTree;

type

  TFmMain = class(TForm)
    DBNavigator1: TDBNavigator;
    MainMenu1: TMainMenu;
    About1: TMenuItem;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    Button1: TButton;
    CheckBox2: TCheckBox;
    Label12: TLabel;
    PageControl2: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    StructureTree1: TStructureTree;
    PageControl1: TPageControl;
    TSCompany: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBMemo1: TDBMemo;
    TSProductSeries: TTabSheet;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBMemo2: TDBMemo;
    TSProduct: TTabSheet;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBMemo3: TDBMemo;
    TSDepartment: TTabSheet;
    ScrollBox: TScrollBox;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    EditDepartmentID: TDBEdit;
    EditDepartmentName: TDBEdit;
    EditCompanyID: TDBEdit;
    TSText: TTabSheet;
    Memo1: TMemo;
    ImageList1: TImageList;
    TabSheet3: TTabSheet;
    Panel2: TPanel;
    Label16: TLabel;
    Image1: TImage;
    Memo2: TMemo;
    Label17: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    DBTreeNavigator1: TDBTreeNavigator;
    FontList1: TFontList;

    procedure About1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DBTreeNavigator1Rejust(Sender: TObject;
      ObjectNode: TTreeNode);
  private
    { Private declarations }

  public
    { Public declarations }

end;

var
  FmMain: TFmMain;

  lastobjnode:Ttreenode;

implementation

uses data, About;

  {$R *.DFM}

procedure TFmMain.About1Click(Sender: TObject);
var
  fmAboutBox : TFmAboutBox;
begin
  FmAboutBox := TFmAboutBox.Create(self);
  try
    FmAboutBox.showModal;
  finally
    FmAboutBox.free;
  end;
end;

 procedure TFmMain.RadioGroup1Click(Sender: TObject);
 var now_itemindex:integer;
 begin

   if DBTreeNavigator1.static then
      now_itemindex:=0
   else if not DBTreeNavigator1.FullDynamic then
      now_itemindex:=1
   else
      now_itemindex:=2;

   if now_itemindex=RadioGroup1.itemindex then
       exit;

   case RadioGroup1.itemindex of
    0:  Begin
           DBTreeNavigator1.static:=true;
        end;
    1:  Begin
           DBTreeNavigator1.items.BeginUpdate;

           DBTreeNavigator1.FullDynamic:=false;
           DBTreeNavigator1.static:=false;

           if DBTreeNavigator1.Active then
              begin
                DBTreeNavigator1.Active:=false;
                DBTreeNavigator1.Active:=true;
              end;

           DBTreeNavigator1.items.EndUpdate;
        end;
    2:  Begin
           DBTreeNavigator1.items.BeginUpdate;

           DBTreeNavigator1.FullDynamic:=True;
           DBTreeNavigator1.static:=false;

           if DBTreeNavigator1.Active then
              begin
                DBTreeNavigator1.Active:=false;
                DBTreeNavigator1.Active:=true;
              end;

           DBTreeNavigator1.items.EndUpdate;
        end;
    end;
end;

procedure TFmMain.CheckBox1Click(Sender: TObject);
begin
  if checkBox1.checked<>DBTreeNavigator1.active then
     DBTreeNavigator1.active:=checkBox1.checked;
end;

procedure TFmMain.Button1Click(Sender: TObject);
begin
     DBTreeNavigator1.refreshcurrentChildrenNode;
end;

procedure TFmMain.DBTreeNavigator1Rejust(Sender: TObject;
  ObjectNode: TTreeNode);
begin
   if checkbox2.checked<>true then exit;

   if ObjectNode.text='Company:CompanyName' then
      pageControl1.activepage:=TSCompany
   else
   if ObjectNode.text='ProductS:ProductSName' then
      pageControl1.activepage:=TSProductseries
   else
   if ObjectNode.text='Product:ProductName' then
      pageControl1.activepage:=TSProduct
   else   if ObjectNode.text='department:DepartmentName' then
      pageControl1.activepage:=TSDepartment
   else
      pageControl1.activepage:=TSText
end;

end.
